- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- File List
- Globals

# udat.h File Reference

C API: DateFormat. More...

`#include "unicode/utypes.h"`
`#include "unicode/ucal.h"`
`#include "unicode/unum.h"`

Go to the source code of this file.

## Typedefs
typedef void * | UDateFormat
| A date formatter.
typedef UDateFormatSymbols | UDateFormatSymbols
| Date format symbols.
## Enumerations
enum | UDateFormatStyle { UDAT_FULL, UDAT_LONG, UDAT_MEDIUM, UDAT_SHORT, UDAT_DEFAULT = UDAT_MEDIUM, UDAT_RELATIVE = (1 << 7), UDAT_FULL_RELATIVE = UDAT_FULL | UDAT_RELATIVE, UDAT_LONG_RELATIVE = UDAT_LONG | UDAT_RELATIVE, UDAT_MEDIUM_RELATIVE = UDAT_MEDIUM | UDAT_RELATIVE, UDAT_SHORT_RELATIVE = UDAT_SHORT | UDAT_RELATIVE, UDAT_NONE = -1, UDAT_IGNORE = -2 }
| The possible date/time format styles. More...
enum | UDateFormatField { UDAT_ERA_FIELD = 0, UDAT_YEAR_FIELD = 1, UDAT_MONTH_FIELD = 2, UDAT_DATE_FIELD = 3, UDAT_HOUR_OF_DAY1_FIELD = 4, UDAT_HOUR_OF_DAY0_FIELD = 5, UDAT_MINUTE_FIELD = 6, UDAT_SECOND_FIELD = 7, UDAT_FRACTIONAL_SECOND_FIELD = 8, UDAT_DAY_OF_WEEK_FIELD = 9, UDAT_DAY_OF_YEAR_FIELD = 10, UDAT_DAY_OF_WEEK_IN_MONTH_FIELD = 11, UDAT_WEEK_OF_YEAR_FIELD = 12, UDAT_WEEK_OF_MONTH_FIELD = 13, UDAT_AM_PM_FIELD = 14, UDAT_HOUR1_FIELD = 15, UDAT_HOUR0_FIELD = 16, UDAT_TIMEZONE_FIELD = 17, UDAT_YEAR_WOY_FIELD = 18, UDAT_DOW_LOCAL_FIELD = 19, UDAT_EXTENDED_YEAR_FIELD = 20, UDAT_JULIAN_DAY_FIELD = 21, UDAT_MILLISECONDS_IN_DAY_FIELD = 22, UDAT_TIMEZONE_RFC_FIELD = 23, UDAT_TIMEZONE_GENERIC_FIELD = 24, UDAT_STANDALONE_DAY_FIELD = 25, UDAT_STANDALONE_MONTH_FIELD = 26, UDAT_QUARTER_FIELD = 27, UDAT_STANDALONE_QUARTER_FIELD = 28, UDAT_TIMEZONE_SPECIAL_FIELD = 29, UDAT_FIELD_COUNT = 30 }
| FieldPosition and UFieldPosition selectors for format fields defined by DateFormat and UDateFormat. More...
enum | UDateFormatSymbolType { UDAT_ERAS, UDAT_MONTHS, UDAT_SHORT_MONTHS, UDAT_WEEKDAYS, UDAT_SHORT_WEEKDAYS, UDAT_AM_PMS, UDAT_LOCALIZED_CHARS, UDAT_ERA_NAMES, UDAT_NARROW_MONTHS, UDAT_NARROW_WEEKDAYS, UDAT_STANDALONE_MONTHS, UDAT_STANDALONE_SHORT_MONTHS, UDAT_STANDALONE_NARROW_MONTHS, UDAT_STANDALONE_WEEKDAYS, UDAT_STANDALONE_SHORT_WEEKDAYS, UDAT_STANDALONE_NARROW_WEEKDAYS, UDAT_QUARTERS, UDAT_SHORT_QUARTERS, UDAT_STANDALONE_QUARTERS, UDAT_STANDALONE_SHORT_QUARTERS }
| The possible types of date format symbols. More...
## Functions
UDateFormat * | udat_open (UDateFormatStyle timeStyle, UDateFormatStyle dateStyle, const char *locale, const UChar *tzID, int32_t tzIDLength, const UChar *pattern, int32_t patternLength, UErrorCode *status)
| Open a new UDateFormat for formatting and parsing dates and times.
void | udat_close (UDateFormat *format)
| Close a UDateFormat.
UDateFormat * | udat_clone (const UDateFormat *fmt, UErrorCode *status)
| Open a copy of a UDateFormat.
int32_t | udat_format (const UDateFormat *format, UDate dateToFormat, UChar *result, int32_t resultLength, UFieldPosition *position, UErrorCode *status)
| Format a date using an UDateFormat.
UDate | udat_parse (const UDateFormat *format, const UChar *text, int32_t textLength, int32_t *parsePos, UErrorCode *status)
| Parse a string into an date/time using a UDateFormat.
void | udat_parseCalendar (const UDateFormat *format, UCalendar *calendar, const UChar *text, int32_t textLength, int32_t *parsePos, UErrorCode *status)
| Parse a string into an date/time using a UDateFormat.
UBool | udat_isLenient (const UDateFormat *fmt)
| Determine if an UDateFormat will perform lenient parsing.
void | udat_setLenient (UDateFormat *fmt, UBool isLenient)
| Specify whether an UDateFormat will perform lenient parsing.
const UCalendar * | udat_getCalendar (const UDateFormat *fmt)
| Get the UCalendar associated with an UDateFormat.
void | udat_setCalendar (UDateFormat *fmt, const UCalendar *calendarToSet)
| Set the UCalendar associated with an UDateFormat.
const UNumberFormat * | udat_getNumberFormat (const UDateFormat *fmt)
| Get the UNumberFormat associated with an UDateFormat.
void | udat_setNumberFormat (UDateFormat *fmt, const UNumberFormat *numberFormatToSet)
| Set the UNumberFormat associated with an UDateFormat.
const char * | udat_getAvailable (int32_t index)
| Get a locale for which date/time formatting patterns are available.
int32_t | udat_countAvailable (void)
| Determine how many locales have date/time formatting patterns available.
UDate | udat_get2DigitYearStart (const UDateFormat *fmt, UErrorCode *status)
| Get the year relative to which all 2-digit years are interpreted.
void | udat_set2DigitYearStart (UDateFormat *fmt, UDate d, UErrorCode *status)
| Set the year relative to which all 2-digit years will be interpreted.
int32_t | udat_toPattern (const UDateFormat *fmt, UBool localized, UChar *result, int32_t resultLength, UErrorCode *status)
| Extract the pattern from a UDateFormat.
void | udat_applyPattern (UDateFormat *format, UBool localized, const UChar *pattern, int32_t patternLength)
| Set the pattern used by an UDateFormat.
int32_t | udat_getSymbols (const UDateFormat *fmt, UDateFormatSymbolType type, int32_t index, UChar *result, int32_t resultLength, UErrorCode *status)
| Get the symbols associated with an UDateFormat.
int32_t | udat_countSymbols (const UDateFormat *fmt, UDateFormatSymbolType type)
| Count the number of particular symbols for an UDateFormat.
void | udat_setSymbols (UDateFormat *format, UDateFormatSymbolType type, int32_t index, UChar *value, int32_t valueLength, UErrorCode *status)
| Set the symbols associated with an UDateFormat.
const char * | udat_getLocaleByType (const UDateFormat *fmt, ULocDataLocaleType type, UErrorCode *status)
| Get the locale for this date format object.

## Detailed Description

C API: DateFormat.

## Date Format C API

Date Format C API consists of functions that convert dates and times from their internal representations to textual form and back again in a language-independent manner. Converting from the internal representation (milliseconds since midnight, January 1, 1970) to text is known as "formatting," and converting from text to millis is known as "parsing." We currently define only one concrete structure UDateFormat, which can handle pretty much all normal date formatting and parsing actions.

Date Format helps you to format and parse dates for any locale. Your code can be completely independent of the locale conventions for months, days of the week, or even the calendar format: lunar vs. solar.

To format a date for the current Locale with default time and date style, use one of the static factory methods:

      UErrorCode status = U_ZERO_ERROR;
      UChar *myString;
      int32_t myStrlen = 0;
      UDateFormat* dfmt = udat_open(UDAT_DEFAULT, UDAT_DEFAULT, NULL, NULL, -1, NULL, -1, &status);
      myStrlen = udat_format(dfmt, myDate, NULL, myStrlen, NULL, &status);
      if (status==U_BUFFER_OVERFLOW_ERROR){
          status=U_ZERO_ERROR;
          myString=(UChar*)malloc(sizeof(UChar) * (myStrlen+1) );
          udat_format(dfmt, myDate, myString, myStrlen+1, NULL, &status);
      }

If you are formatting multiple numbers, it is more efficient to get the format and use it multiple times so that the system doesn't have to fetch the information about the local language and country conventions multiple times.

      UErrorCode status = U_ZERO_ERROR;
      int32_t i, myStrlen = 0;
      UChar* myString;
      char buffer[1024];
      UDate myDateArr[] = { 0.0, 100000000.0, 2000000000.0 }; // test values
      UDateFormat* df = udat_open(UDAT_DEFAULT, UDAT_DEFAULT, NULL, NULL, -1, NULL, 0, &status);
      for (i = 0; i < 3; i++) {
          myStrlen = udat_format(df, myDateArr[i], NULL, myStrlen, NULL, &status);
          if(status == U_BUFFER_OVERFLOW_ERROR){
              status = U_ZERO_ERROR;
              myString = (UChar*)malloc(sizeof(UChar) * (myStrlen+1) );
              udat_format(df, myDateArr[i], myString, myStrlen+1, NULL, &status);
              printf("%s\n", u_austrcpy(buffer, myString) );
              free(myString);
          }
      }

To get specific fields of a date, you can use UFieldPosition to get specific fields.

      UErrorCode status = U_ZERO_ERROR;
      UFieldPosition pos;
      UChar *myString;
      int32_t myStrlen = 0;
      char buffer[1024];

      pos.field = 1;  // Same as the DateFormat::EField enum
      UDateFormat* dfmt = udat_open(UDAT_DEFAULT, UDAT_DEFAULT, NULL, -1, NULL, 0, &status);
      myStrlen = udat_format(dfmt, myDate, NULL, myStrlen, &pos, &status);
      if (status==U_BUFFER_OVERFLOW_ERROR){
          status=U_ZERO_ERROR;
          myString=(UChar*)malloc(sizeof(UChar) * (myStrlen+1) );
          udat_format(dfmt, myDate, myString, myStrlen+1, &pos, &status);
      }
      printf("date format: %s\n", u_austrcpy(buffer, myString));
      buffer[pos.endIndex] = 0;   // NULL terminate the string.
      printf("UFieldPosition position equals %s\n", &buffer[pos.beginIndex]);

To format a date for a different Locale, specify it in the call to udat_open()

            UDateFormat* df = udat_open(UDAT_SHORT, UDAT_SHORT, "fr_FR", NULL, -1, NULL, 0, &status);

You can use a DateFormat API udat_parse() to parse.

      UErrorCode status = U_ZERO_ERROR;
      int32_t parsepos=0;
      UDate myDate = udat_parse(df, myString, u_strlen(myString), &parsepos, &status);

You can pass in different options for the arguments for date and time style to control the length of the result; from SHORT to MEDIUM to LONG to FULL. The exact result depends on the locale, but generally: see UDateFormatStyle for more details

- UDAT_SHORT is completely numeric, such as 12/13/52 or 3:30pm
- UDAT_MEDIUM is longer, such as Jan 12, 1952
- UDAT_LONG is longer, such as January 12, 1952 or 3:30:32pm
- UDAT_FULL is pretty completely specified, such as Tuesday, April 12, 1952 AD or 3:30:42pm PST.

You can also set the time zone on the format if you wish.

You can also use forms of the parse and format methods with Parse Position and UFieldPosition to allow you to

- Progressively parse through pieces of a string.
- Align any particular field, or find out where it is for selection on the screen.

Definition in file udat.h.

## Typedef Documentation

typedef void* UDateFormat

A date formatter.

For usage in C programs.

Stable:
  ICU 2.6

Definition at line 138 of file udat.h.

typedef struct UDateFormatSymbols UDateFormatSymbols

Date format symbols.

For usage in C programs.

Stable:
  ICU 2.6

Definition at line 745 of file udat.h.

## Enumeration Type Documentation

enum UDateFormatField

FieldPosition and UFieldPosition selectors for format fields defined by DateFormat and UDateFormat.

Stable:
  ICU 3.0

Enumerator:

  UDAT_ERA_FIELD | FieldPosition and UFieldPosition selector for 'G' field alignment, corresponding to the UCAL_ERA field. Stable: ICU 3.0
  UDAT_YEAR_FIELD | FieldPosition and UFieldPosition selector for 'y' field alignment, corresponding to the UCAL_YEAR field. Stable: ICU 3.0
  UDAT_MONTH_FIELD | FieldPosition and UFieldPosition selector for 'M' field alignment, corresponding to the UCAL_MONTH field. Stable: ICU 3.0
  UDAT_DATE_FIELD | FieldPosition and UFieldPosition selector for 'd' field alignment, corresponding to the UCAL_DATE field. Stable: ICU 3.0
  UDAT_HOUR_OF_DAY1_FIELD | FieldPosition and UFieldPosition selector for 'k' field alignment, corresponding to the UCAL_HOUR_OF_DAY field. UDAT_HOUR_OF_DAY1_FIELD is used for the one-based 24-hour clock. For example, 23:59 + 01:00 results in 24:59. Stable: ICU 3.0
  UDAT_HOUR_OF_DAY0_FIELD | FieldPosition and UFieldPosition selector for 'H' field alignment, corresponding to the UCAL_HOUR_OF_DAY field. UDAT_HOUR_OF_DAY0_FIELD is used for the zero-based 24-hour clock. For example, 23:59 + 01:00 results in 00:59. Stable: ICU 3.0
  UDAT_MINUTE_FIELD | FieldPosition and UFieldPosition selector for 'm' field alignment, corresponding to the UCAL_MINUTE field. Stable: ICU 3.0
  UDAT_SECOND_FIELD | FieldPosition and UFieldPosition selector for 's' field alignment, corresponding to the UCAL_SECOND field. Stable: ICU 3.0
  UDAT_FRACTIONAL_SECOND_FIELD | FieldPosition and UFieldPosition selector for 'S' field alignment, corresponding to the UCAL_MILLISECOND field. Stable: ICU 3.0
  UDAT_DAY_OF_WEEK_FIELD | FieldPosition and UFieldPosition selector for 'E' field alignment, corresponding to the UCAL_DAY_OF_WEEK field. Stable: ICU 3.0
  UDAT_DAY_OF_YEAR_FIELD | FieldPosition and UFieldPosition selector for 'D' field alignment, corresponding to the UCAL_DAY_OF_YEAR field. Stable: ICU 3.0
  UDAT_DAY_OF_WEEK_IN_MONTH_FIELD | FieldPosition and UFieldPosition selector for 'F' field alignment, corresponding to the UCAL_DAY_OF_WEEK_IN_MONTH field. Stable: ICU 3.0
  UDAT_WEEK_OF_YEAR_FIELD | FieldPosition and UFieldPosition selector for 'w' field alignment, corresponding to the UCAL_WEEK_OF_YEAR field. Stable: ICU 3.0
  UDAT_WEEK_OF_MONTH_FIELD | FieldPosition and UFieldPosition selector for 'W' field alignment, corresponding to the UCAL_WEEK_OF_MONTH field. Stable: ICU 3.0
  UDAT_AM_PM_FIELD | FieldPosition and UFieldPosition selector for 'a' field alignment, corresponding to the UCAL_AM_PM field. Stable: ICU 3.0
  UDAT_HOUR1_FIELD | FieldPosition and UFieldPosition selector for 'h' field alignment, corresponding to the UCAL_HOUR field. UDAT_HOUR1_FIELD is used for the one-based 12-hour clock. For example, 11:30 PM + 1 hour results in 12:30 AM. Stable: ICU 3.0
  UDAT_HOUR0_FIELD | FieldPosition and UFieldPosition selector for 'K' field alignment, corresponding to the UCAL_HOUR field. UDAT_HOUR0_FIELD is used for the zero-based 12-hour clock. For example, 11:30 PM + 1 hour results in 00:30 AM. Stable: ICU 3.0
  UDAT_TIMEZONE_FIELD | FieldPosition and UFieldPosition selector for 'z' field alignment, corresponding to the UCAL_ZONE_OFFSET and UCAL_DST_OFFSET fields. Stable: ICU 3.0
  UDAT_YEAR_WOY_FIELD | FieldPosition and UFieldPosition selector for 'Y' field alignment, corresponding to the UCAL_YEAR_WOY field. Stable: ICU 3.0
  UDAT_DOW_LOCAL_FIELD | FieldPosition and UFieldPosition selector for 'e' field alignment, corresponding to the UCAL_DOW_LOCAL field. Stable: ICU 3.0
  UDAT_EXTENDED_YEAR_FIELD | FieldPosition and UFieldPosition selector for 'u' field alignment, corresponding to the UCAL_EXTENDED_YEAR field. Stable: ICU 3.0
  UDAT_JULIAN_DAY_FIELD | FieldPosition and UFieldPosition selector for 'g' field alignment, corresponding to the UCAL_JULIAN_DAY field. Stable: ICU 3.0
  UDAT_MILLISECONDS_IN_DAY_FIELD | FieldPosition and UFieldPosition selector for 'A' field alignment, corresponding to the UCAL_MILLISECONDS_IN_DAY field. Stable: ICU 3.0
  UDAT_TIMEZONE_RFC_FIELD | FieldPosition and UFieldPosition selector for 'Z' field alignment, corresponding to the UCAL_ZONE_OFFSET and UCAL_DST_OFFSET fields. Stable: ICU 3.0
  UDAT_TIMEZONE_GENERIC_FIELD | FieldPosition and UFieldPosition selector for 'v' field alignment, corresponding to the UCAL_ZONE_OFFSET field. Stable: ICU 3.4
  UDAT_STANDALONE_DAY_FIELD | FieldPosition selector for 'c' field alignment, corresponding to the UCAL_DAY field. This displays the stand alone day name, if available. Stable: ICU 3.4
  UDAT_STANDALONE_MONTH_FIELD | FieldPosition selector for 'L' field alignment, corresponding to the UCAL_MONTH field. This displays the stand alone month name, if available. Stable: ICU 3.4
  UDAT_QUARTER_FIELD | FieldPosition selector for "Q" field alignment, corresponding to quarters. This is implemented using the UCAL_MONTH field. This displays the quarter. Stable: ICU 3.6
  UDAT_STANDALONE_QUARTER_FIELD | FieldPosition selector for the "q" field alignment, corresponding to stand-alone quarters. This is implemented using the UCAL_MONTH field. This displays the stand-alone quarter. Stable: ICU 3.6
  UDAT_TIMEZONE_SPECIAL_FIELD | FieldPosition and UFieldPosition selector for 'V' field alignment, corresponding to the UCAL_ZONE_OFFSET field. Stable: ICU 3.8
  UDAT_FIELD_COUNT | Number of FieldPosition and UFieldPosition selectors for DateFormat and UDateFormat. Valid selectors range from 0 to UDAT_FIELD_COUNT-1. This value is subject to change if new fields are defined in the future. Stable: ICU 3.0

Definition at line 179 of file udat.h.

enum UDateFormatStyle

The possible date/time format styles.

Stable:
  ICU 2.6

Enumerator:

  UDAT_FULL | Full style.
  UDAT_LONG | Long style.
  UDAT_MEDIUM | Medium style.
  UDAT_SHORT | Short style.
  UDAT_DEFAULT | Default style.
  UDAT_RELATIVE | Bitfield for relative date.
  UDAT_NONE | No style.
  UDAT_IGNORE | for internal API use only

Definition at line 143 of file udat.h.

enum UDateFormatSymbolType

The possible types of date format symbols.

Stable:
  ICU 2.6

Enumerator:

  UDAT_ERAS | The era names, for example AD.
  UDAT_MONTHS | The month names, for example February.
  UDAT_SHORT_MONTHS | The short month names, for example Feb.
  UDAT_WEEKDAYS | The weekday names, for example Monday.
  UDAT_SHORT_WEEKDAYS | The short weekday names, for example Mon.
  UDAT_AM_PMS | The AM/PM names, for example AM.
  UDAT_LOCALIZED_CHARS | The localized characters.
  UDAT_ERA_NAMES | The long era names, for example Anno Domini.
  UDAT_NARROW_MONTHS | The narrow month names, for example F.
  UDAT_NARROW_WEEKDAYS | The narrow weekday names, for example N.
  UDAT_STANDALONE_MONTHS | Standalone context versions of months.
  UDAT_STANDALONE_WEEKDAYS | Standalone context versions of weekdays.
  UDAT_QUARTERS | The quarters, for example 1st Quarter.
  UDAT_SHORT_QUARTERS | The short quarter names, for example Q1.
  UDAT_STANDALONE_QUARTERS | Standalone context versions of quarters.

Definition at line 701 of file udat.h.

## Function Documentation

void udat_applyPattern | ( | UDateFormat * | format,
|  | UBool | localized,
|  | const UChar * | pattern,
|  | int32_t | patternLength |
| ) |  |  |

Set the pattern used by an UDateFormat.

The pattern should follow the pattern syntax rules.

Parameters:

  | format | The formatter to set.
  | localized | TRUE if the pattern is localized, FALSE otherwise.
  | pattern | The new pattern
  | patternLength | The length of pattern, or -1 if null-terminated.

See also:
  udat_toPattern

Stable:
  ICU 2.0

UDateFormat* udat_clone | ( | const UDateFormat * | fmt,
|  | UErrorCode * | status |
| ) |  |  |

Open a copy of a UDateFormat.

This function performs a deep copy.

Parameters:

  | fmt | The format to copy
  | status | A pointer to an UErrorCode to receive any errors.

Returns:
  A pointer to a UDateFormat identical to fmt.

Stable:
  ICU 2.0

void udat_close | ( | UDateFormat * | format | ) |

Close a UDateFormat.

Once closed, a UDateFormat may no longer be used.

Parameters:

  | format | The formatter to close.

Stable:
  ICU 2.0

int32_t udat_countAvailable | ( | void |  | ) |

Determine how many locales have date/time formatting patterns available.

This function is most useful as determining the loop ending condition for calls to udat_getAvailable.

Returns:
  The number of locales for which date/time formatting patterns are available.

See also:
  udat_getAvailable

Stable:
  ICU 2.0

int32_t udat_countSymbols | ( | const UDateFormat * | fmt,
|  | UDateFormatSymbolType | type |
| ) |  |  |

Count the number of particular symbols for an UDateFormat.

This function is most useful as for detemining the loop termination condition for calls to udat_getSymbols.

Parameters:

  | fmt | The formatter to query.
  | type | The type of symbols to count. One of UDAT_ERAS, UDAT_MONTHS, UDAT_SHORT_MONTHS, UDAT_WEEKDAYS, UDAT_SHORT_WEEKDAYS, UDAT_AM_PMS, or UDAT_LOCALIZED_CHARS

Returns:
  The number of symbols of type type.

See also:
  udat_getSymbols

  udat_setSymbols

Stable:
  ICU 2.0

int32_t udat_format | ( | const UDateFormat * | format,
|  | UDate | dateToFormat,
|  | UChar * | result,
|  | int32_t | resultLength,
|  | UFieldPosition * | position,
|  | UErrorCode * | status |
| ) |  |  |

Format a date using an UDateFormat.

The date will be formatted using the conventions specified in udat_open

Parameters:

  | format | The formatter to use
  | dateToFormat | The date to format
  | result | A pointer to a buffer to receive the formatted number.
  | resultLength | The maximum size of result.
  | position | A pointer to a UFieldPosition. On input, position->field is read. On output, position->beginIndex and position->endIndex indicate the beginning and ending indices of field number position->field, if such a field exists. This parameter may be NULL, in which case no field position data is returned.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  The total buffer size needed; if greater than resultLength, the output was truncated.

See also:
  udat_parse

  UFieldPosition

Stable:
  ICU 2.0

UDate udat_get2DigitYearStart | ( | const UDateFormat * | fmt,
|  | UErrorCode * | status |
| ) |  |  |

Get the year relative to which all 2-digit years are interpreted.

For example, if the 2-digit start year is 2100, the year 99 will be interpreted as 2199.

Parameters:

  | fmt | The formatter to query.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  The year relative to which all 2-digit years are interpreted.

See also:
  udat_Set2DigitYearStart

Stable:
  ICU 2.0

const char* udat_getAvailable | ( | int32_t | index | ) |

Get a locale for which date/time formatting patterns are available.

A UDateFormat in a locale returned by this function will perform the correct formatting and parsing for the locale.

Parameters:

  | index | The index of the desired locale.

Returns:
  A locale for which date/time formatting patterns are available, or 0 if none.

See also:
  udat_countAvailable

Stable:
  ICU 2.0

const UCalendar* udat_getCalendar | ( | const UDateFormat * | fmt | ) |

Get the UCalendar associated with an UDateFormat.

A UDateFormat uses a UCalendar to convert a raw value to, for example, the day of the week.

Parameters:

  | fmt | The formatter to query.

Returns:
  A pointer to the UCalendar used by fmt.

See also:
  udat_setCalendar

Stable:
  ICU 2.0

const char* udat_getLocaleByType | ( | const UDateFormat * | fmt,
|  | ULocDataLocaleType | type,
|  | UErrorCode * | status |
| ) |  |  |

Get the locale for this date format object.

You can choose between valid and actual locale.

Parameters:

  | fmt | The formatter to get the locale from
  | type | type of the locale we're looking for (valid or actual)
  | status | error code for the operation

Returns:
  the locale name

Stable:
  ICU 2.8

const UNumberFormat* udat_getNumberFormat | ( | const UDateFormat * | fmt | ) |

Get the UNumberFormat associated with an UDateFormat.

A UDateFormat uses a UNumberFormat to format numbers within a date, for example the day number.

Parameters:

  | fmt | The formatter to query.

Returns:
  A pointer to the UNumberFormat used by fmt to format numbers.

See also:
  udat_setNumberFormat

Stable:
  ICU 2.0

int32_t udat_getSymbols | ( | const UDateFormat * | fmt,
|  | UDateFormatSymbolType | type,
|  | int32_t | index,
|  | UChar * | result,
|  | int32_t | resultLength,
|  | UErrorCode * | status |
| ) |  |  |

Get the symbols associated with an UDateFormat.

The symbols are what a UDateFormat uses to represent locale-specific data, for example month or day names.

Parameters:

  | fmt | The formatter to query.
  | type | The type of symbols to get. One of UDAT_ERAS, UDAT_MONTHS, UDAT_SHORT_MONTHS, UDAT_WEEKDAYS, UDAT_SHORT_WEEKDAYS, UDAT_AM_PMS, or UDAT_LOCALIZED_CHARS
  | index | The desired symbol of type type.
  | result | A pointer to a buffer to receive the pattern.
  | resultLength | The maximum size of result.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  The total buffer size needed; if greater than resultLength, the output was truncated.

See also:
  udat_countSymbols

  udat_setSymbols

Stable:
  ICU 2.0

UBool udat_isLenient | ( | const UDateFormat * | fmt | ) |

Determine if an UDateFormat will perform lenient parsing.

With lenient parsing, the parser may use heuristics to interpret inputs that do not precisely match the pattern. With strict parsing, inputs must match the pattern.

Parameters:

  | fmt | The formatter to query

Returns:
  TRUE if fmt is set to perform lenient parsing, FALSE otherwise.

See also:
  udat_setLenient

Stable:
  ICU 2.0

UDateFormat* udat_open | ( | UDateFormatStyle | timeStyle,
|  | UDateFormatStyle | dateStyle,
|  | const char * | locale,
|  | const UChar * | tzID,
|  | int32_t | tzIDLength,
|  | const UChar * | pattern,
|  | int32_t | patternLength,
|  | UErrorCode * | status |
| ) |  |  |

Open a new UDateFormat for formatting and parsing dates and times.

A UDateFormat may be used to format dates in calls to udat_format, and to parse dates in calls to udat_parse.

Parameters:

  | timeStyle | The style used to format times; one of UDAT_FULL, UDAT_LONG, UDAT_MEDIUM, UDAT_SHORT, or UDAT_DEFAULT
  | dateStyle | The style used to format dates; one of UDAT_FULL, UDAT_LONG, UDAT_MEDIUM, UDAT_SHORT, or UDAT_DEFAULT
  | locale | The locale specifying the formatting conventions
  | tzID | A timezone ID specifying the timezone to use. If 0, use the default timezone.
  | tzIDLength | The length of tzID, or -1 if null-terminated.
  | pattern | A pattern specifying the format to use.
  | patternLength | The number of characters in the pattern, or -1 if null-terminated.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  A pointer to a UDateFormat to use for formatting dates and times, or 0 if an error occurred.

Stable:
  ICU 2.0

UDate udat_parse | ( | const UDateFormat * | format,
|  | const UChar * | text,
|  | int32_t | textLength,
|  | int32_t * | parsePos,
|  | UErrorCode * | status |
| ) |  |  |

Parse a string into an date/time using a UDateFormat.

The date will be parsed using the conventions specified in udat_open

Parameters:

  | format | The formatter to use.
  | text | The text to parse.
  | textLength | The length of text, or -1 if null-terminated.
  | parsePos | If not 0, on input a pointer to an integer specifying the offset at which to begin parsing. If not 0, on output the offset at which parsing ended.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  The value of the parsed date/time

See also:
  udat_format

Stable:
  ICU 2.0

void udat_parseCalendar | ( | const UDateFormat * | format,
|  | UCalendar * | calendar,
|  | const UChar * | text,
|  | int32_t | textLength,
|  | int32_t * | parsePos,
|  | UErrorCode * | status |
| ) |  |  |

Parse a string into an date/time using a UDateFormat.

The date will be parsed using the conventions specified in udat_open

Parameters:

  | format | The formatter to use.
  | calendar | The calendar in which to store the parsed data.
  | text | The text to parse.
  | textLength | The length of text, or -1 if null-terminated.
  | parsePos | If not 0, on input a pointer to an integer specifying the offset at which to begin parsing. If not 0, on output the offset at which parsing ended.
  | status | A pointer to an UErrorCode to receive any errors

See also:
  udat_format

Stable:
  ICU 2.0

void udat_set2DigitYearStart | ( | UDateFormat * | fmt,
|  | UDate | d,
|  | UErrorCode * | status |
| ) |  |  |

Set the year relative to which all 2-digit years will be interpreted.

For example, if the 2-digit start year is 2100, the year 99 will be interpreted as 2199.

Parameters:

  | fmt | The formatter to set.
  | d | The year relative to which all 2-digit years will be interpreted.
  | status | A pointer to an UErrorCode to receive any errors

See also:
  udat_Set2DigitYearStart

Stable:
  ICU 2.0

void udat_setCalendar | ( | UDateFormat * | fmt,
|  | const UCalendar * | calendarToSet |
| ) |  |  |

Set the UCalendar associated with an UDateFormat.

A UDateFormat uses a UCalendar to convert a raw value to, for example, the day of the week.

Parameters:

  | fmt | The formatter to set.
  | calendarToSet | A pointer to an UCalendar to be used by fmt.

See also:
  udat_setCalendar

Stable:
  ICU 2.0

void udat_setLenient | ( | UDateFormat * | fmt,
|  | UBool | isLenient |
| ) |  |  |

Specify whether an UDateFormat will perform lenient parsing.

With lenient parsing, the parser may use heuristics to interpret inputs that do not precisely match the pattern. With strict parsing, inputs must match the pattern.

Parameters:

  | fmt | The formatter to set
  | isLenient | TRUE if fmt should perform lenient parsing, FALSE otherwise.

See also:
  dat_isLenient

Stable:
  ICU 2.0

void udat_setNumberFormat | ( | UDateFormat * | fmt,
|  | const UNumberFormat * | numberFormatToSet |
| ) |  |  |

Set the UNumberFormat associated with an UDateFormat.

A UDateFormat uses a UNumberFormat to format numbers within a date, for example the day number.

Parameters:

  | fmt | The formatter to set.
  | numberFormatToSet | A pointer to the UNumberFormat to be used by fmt to format numbers.

See also:
  udat_getNumberFormat

Stable:
  ICU 2.0

void udat_setSymbols | ( | UDateFormat * | format,
|  | UDateFormatSymbolType | type,
|  | int32_t | index,
|  | UChar * | value,
|  | int32_t | valueLength,
|  | UErrorCode * | status |
| ) |  |  |

Set the symbols associated with an UDateFormat.

The symbols are what a UDateFormat uses to represent locale-specific data, for example month or day names.

Parameters:

  | format | The formatter to set
  | type | The type of symbols to set. One of UDAT_ERAS, UDAT_MONTHS, UDAT_SHORT_MONTHS, UDAT_WEEKDAYS, UDAT_SHORT_WEEKDAYS, UDAT_AM_PMS, or UDAT_LOCALIZED_CHARS
  | index | The index of the symbol to set of type type.
  | value | The new value
  | valueLength | The length of value, or -1 if null-terminated
  | status | A pointer to an UErrorCode to receive any errors

See also:
  udat_getSymbols

  udat_countSymbols

Stable:
  ICU 2.0

int32_t udat_toPattern | ( | const UDateFormat * | fmt,
|  | UBool | localized,
|  | UChar * | result,
|  | int32_t | resultLength,
|  | UErrorCode * | status |
| ) |  |  |

Extract the pattern from a UDateFormat.

The pattern will follow the pattern syntax rules.

Parameters:

  | fmt | The formatter to query.
  | localized | TRUE if the pattern should be localized, FALSE otherwise.
  | result | A pointer to a buffer to receive the pattern.
  | resultLength | The maximum size of result.
  | status | A pointer to an UErrorCode to receive any errors

Returns:
  The total buffer size needed; if greater than resultLength, the output was truncated.

See also:
  udat_applyPattern

Stable:
  ICU 2.0